/*
 * FILENAME:    utils.js
 * VERSION:     0.256 (10/18/2011)
 * AUTHOR:      Tiffany Chao (tchao@cs.umd.edu)
 */

var utils = function(utils, jQuery, undefined) {
////// visible ////////////////////////////////////////////////////////////////
    var visible = {};
    
    
    visible.init = function() {
        // prepare required Array functions (from MDN docs)
        if (!Array.prototype.filter) {
            Array.prototype.filter = function(fun, thisp) {
                "use strict";
                
                if (this === void 0 || this === null)
                    throw new TypeError();
                    
                var t = Object(this);
                var len = t.length >>> 0;
                
                if (typeof fun !== "function")
                    throw new TypeError();
                    
                var res = [];
                var thisp = arguments[1];
                
                for (var i = 0; i < len; i++) {
                    if (i in t) {
                        var val = t[i];             // in case fun mutates this
                        
                        if (fun.call(thisp, val, i, t))
                        res.push(val);
                    }
                }
                return res;
            };
        }
        
        if (!Array.prototype.indexOf) {
            Array.prototype.indexOf = function (searchElement, fromIndex) {
                "use strict";
                
                if (this === void 0 || this === null)
                    throw new TypeError();
                    
                var t = Object(this);
                var len = t.length >>> 0;
                
                if (len === 0)
                    return -1;
                    
                var n = 0;
    
                if (arguments.length > 0) {
                    n = Number(arguments[1]);
                      
                    if (n !== n) {      // shortcut for verifying if it's NaN
                        n = 0;
                    } else if (n !== 0 && n !== Infinity && n !== -Infinity) {
                        n = (n > 0 || -1) * Math.floor(Math.abs(n));  
                    }
                }
    
                if (n >= len)
                    return -1;
                    
                var k = n >= 0 ? n : Math.max(len - Math.abs(n), 0);
                
                for (; k < len; k++) {
                    if (k in t && t[k] === searchElement)
                        return k;
                }
                return -1;
            }
        }
    };
    
    visible.getStorageItem = function(key) {
        if ($.browser.webkit) {
            return sessionStorage.getItem(key);
        } else {
            return getCookie(key);
        }
    };
    
    visible.setStorageItem = function(key, value, days) {
        if ($.browser.webkit) {
            sessionStorage.setItem(key, value);
        } else {
            setCookie(key, value, days);
        }
    };
    
////// hidden /////////////////////////////////////////////////////////////////
    function getCookie(name) {
        var cookies = document.cookie.split(";");
        
        for (var i = 0; i < cookies.length; i++) {
            var key = cookies[i].slice(0, cookies[i].indexOf("="));
            var value = cookies[i].slice(cookies[i].indexOf("=") + 1);
            key = key.replace(/^\s+|\s+$/g, "");
            
            if (key === name) {
                return unescape(value);
            }
        }
        return null;
    }
    
    function setCookie(name, value, days) {
        var expires = new Date();
        expires.setDate(expires.getDate() + days);
        value = escape(value) + ((days) ? "" : "; expires=" +
                expires.toUTCString());
        document.cookie = name + "=" + value;
    }
    
    // expose interface
    return visible;
}(window.utils = window.utils || {}, $);
